//*****************************************************************************
//
//	Protokoll fuer UART0
//
//*****************************************************************************
#include <avr/io.h>
#include <stdint.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include "uart0.h"
#include "proto0.h"
#include "kommand0.h"
#include <string.h>
#include <stdlib.h>
#include "watchdog.h"

#define STARTKENNUNG 0x24
#define ENDEKENNUNG  0x0d
#define START        0x01
#define ENDE         0x00


char c_str[80];
unsigned char uc_zeichen,uc_uartstatus = 0;


//*****************************************************************************
//	Protokoll - Zeichenauswertung der UART0
//  Input:	-
//	Output:	-
//*****************************************************************************
void receive_uart0(void)
{
unsigned char uc_x;

  uc_x = UART0_RX();

  watchdog_reset();
 
  if (uc_uartstatus == START)
   {
     c_str[uc_zeichen] = uc_x;
	 uc_zeichen++;
   }
  
  if (uc_x == STARTKENNUNG)
   {
      uc_uartstatus = START;
	  uc_zeichen = 0;
   }	  

  watchdog_reset();

  if ((uc_uartstatus == START) && (uc_x == ENDEKENNUNG)) 
   {
      uc_uartstatus = ENDE;
	  if (uc_zeichen > 0) uc_zeichen--;
	  c_str[uc_zeichen] = '\0';
	  Kommandointerpreter0(c_str);
   }	    

  watchdog_reset();
}


//*****************************************************************************
//	Protokoll - String ueber UART0 an PC senden
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_UART0(char * pc_str)
{
char c_start[2] = {STARTKENNUNG,0x00};
char c_ende[2]  = {ENDEKENNUNG,0x00};

   watchdog_reset();
   strcpy(c_str,c_start);
   strcat(c_str,pc_str);
   watchdog_reset();
   strcat(c_str,c_ende);
   watchdog_reset();

   UART0_TXStr(c_str);
   strcpy(c_str,""); 
   watchdog_reset();
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertL(unsigned long ul_x)
{
char c_txt[20];

   watchdog_reset();
 
   strcpy(c_txt,"LONG,");
   ltoa(ul_x,c_txt+5,10);
 
   watchdog_reset();
 
   sende_UART0(c_txt);
   
   watchdog_reset();
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertI(unsigned int ui_x)
{
char c_txt[20];

   watchdog_reset();
 
   strcpy(c_txt,"INT,");
   itoa(ui_x,c_txt+4,10);

   watchdog_reset();

   sende_UART0(c_txt);
 
   watchdog_reset();
}


//*****************************************************************************
//	Protokoll - Zahl an PC senden //TEST
//  Input:	-
//	Output:	-
//*****************************************************************************
void sende_WertH(unsigned int ui_x)
{
char c_txt[20];

   watchdog_reset();
 
   strcpy(c_txt,"INT Hex,");
   itoa(ui_x,c_txt+4,16);

   watchdog_reset();

   sende_UART0(c_txt);
 
   watchdog_reset();
}


//*****************************************************************************
//	Protokoll - HexZahl nach int konvertieren
//  Input:	String Hexzahl
//	Output:	Integer Zahl
//*****************************************************************************
unsigned int atoh(char * pc_str)
{
unsigned int ui_x=0,ui_db;
unsigned char uc_len,uc_anz,uc_cnt=0;

   watchdog_reset();
   uc_len = strlen(pc_str);
   if (uc_len > 0)
   {
     for(uc_anz=uc_len;uc_anz > 0;uc_anz--)
	 { 
	    watchdog_reset();
	    if (pc_str[uc_anz-1] > 0x39) ui_db = pc_str[uc_anz-1] - 0x37;
		                        else ui_db = pc_str[uc_anz-1] - 0x30;
	    if (ui_db > 0x0F) ui_db = pc_str[uc_anz-1] - 0x57;	
		watchdog_reset();							
		ui_db = ui_db << uc_cnt;						
		ui_x = ui_x | ui_db;
		watchdog_reset();	
		uc_cnt = uc_cnt +4;					
	 }
   }
   return(ui_x);
}

