//*****************************************************************************
//
//	Grundinitialisierung des ATmega
//
//*****************************************************************************
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>
#include <stdlib.h>
#include <avr/wdt.h>
#include "watchdog.h"

#define WDR   asm("WDR");

//*****************************************************************************
//	Initialisierung Watchdogtimer
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_set(unsigned char uc_wdt_prescale)
{
 	 WDR;
     WDTCSR = 0x00;
 	 WDTCSR |= (uc_wdt_prescale & 0x07);		   //Vorteiler setzen
	 if ((uc_wdt_prescale & 0x08) == 0x08) WDTCSR |= 0x20;
}


//*****************************************************************************
//	Einschalten des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_enable(void)
{
     WDR;
	 WDTCSR &= 0x27;
	 WDTCSR |= 0x18;
}


//*****************************************************************************
//	Ausschalten des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_disable(void)
{
 	 WDTCSR |= 0x18;
 	 WDTCSR |= 0x08;
	 WDTCSR &= 0x27;
}


//*****************************************************************************
//	Ruecksetzen des Watchdogtimers
//  Input:	-
//	Output:	-
//*****************************************************************************

void watchdog_reset(void)
{
     WDR;
}	 


	
